Subject: Re: Fwd: [BUG] Bisected Gianfar not receiving any traffic

From: Claudiu Manoil <[email-masked]>
Date: Mon, 10 Jun 2013 13:03:43 +0300

Ok, this is a TSEC controller (an old model indeed) and looks like
it doesn't have the frame receive indication (RXF) field in RSTAT.
I'll send fix for this case asap.
I think the real problem here is that the driver supports multiple
rings per interrupt line. With a single ring per interrupt / CPU,
we would get rid of the overhead and related issues of looking for
active rings in the napi poll routine.

Claudiu

On 6/10/2013 11:33 AM, Michael Guntsche wrote:
> Hello Claudiu,
>
> The Board in question is a Mikrotik Routerboard RB600A, which is
> using a MPC8343E.
>
> /Michael
>
> On Mon, Jun 10, 2013 at 10:29 AM, Claudiu Manoil
> <[email-masked]> wrote:
>> Hello,
>>
>> Please provide the model of your board. Commit 6be5ed3fef568 relies
>> on correct indication from H/W for Rx processing, so we should
>> check whether the right register/mask are being used for that model
>> or whether there's a missing errata. One way to confirm this is by
>> checking if Rx processing (and not Tx) is entered with
>> num_act_queues == 0 (the RXF indication set to 0).
>>
>> Thanks, Claudiu
>>
>>
>> On 6/9/2013 11:28 PM, Michael Guntsche wrote:
>>>
>>> Forwarded to the correct mailing list address.
>>>
>>>
>>> ---------- Forwarded message ---------- From: Michael Guntsche
>>> <[email-masked]> Date: Sun, Jun 9, 2013 at 10:26
>>> PM Subject: [BUG] Bisected Gianfar not receiving any traffic To:
>>> [email-masked] Cc: Claudiu Manoil
>>> <[email-masked]>
>>>
>>>
>>> Good evening,
>>>
>>> While testing one of my powerpc based embedded ports I noticed
>>> that with any 3.10-rc kernel ethernet traffic was dead on my two
>>> gianfar NICs. The strange thing was that apparetnly outbound
>>> broadcasts seemed to work since avahi correctly registered the
>>> name of the board. I bisected it to the following commit.
>>>
>>> 6be5ed3fef568 gianfar: Poll only active Rx queues
>>>
>>> Reverting this commit on 3.10-rc4 made both gianfar devices work
>>> again. This is a rather old board so it could be that the
>>> register that's used here is just plain wrong in my case. A few
>>> years ago I had a similar issue where the implementation on the
>>> board here apparently did not work correctly.
>>>
>>> http://marc.info/?l=linux-netdev&m=131297524825104&w=2
>>>
>>> In that case a flag was bogus as well. If you need more
>>> information or want me to test a patch please add me as CC since
>>> I am not subscribed to the list.
>>>
>>> Kind regards, Michael Guntsche -- To unsubscribe from this list:
>>> send the line "unsubscribe netdev" in the body of a message to
>>> [email-masked] More majordomo info at
>>> http://vger.kernel.org/majordomo-info.html
>>>
>>>
>>
>>
> -- To unsubscribe from this list: send the line "unsubscribe netdev"
> in the body of a message to [email-masked] More majordomo
> info at  http://vger.kernel.org/majordomo-info.html
>
>